
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Watermark_profilesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const watermark_profiles = await db.watermark_profiles.create(
            {
                id: data.id || undefined,
        
        name: data.name
        ||
        null
            ,
            
        mode: data.mode
        ||
        null
            ,
            
        default_text_template: data.default_text_template
        ||
        null
            ,
            
        opacity: data.opacity
        ||
        null
            ,
            
        position: data.position
        ||
        null
            ,
            
        scale: data.scale
        ||
        null
            ,
            
        enabled: data.enabled
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await watermark_profiles.setOrganization(currentUser.organization.id || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.watermark_profiles.getTableName(),
                belongsToColumn: 'watermark_image',
                belongsToId: watermark_profiles.id,
            },
            data.watermark_image,
            options,
        );
        

        return watermark_profiles;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const watermark_profilesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                name: item.name
            ||
            null
            ,
            
                mode: item.mode
            ||
            null
            ,
            
                default_text_template: item.default_text_template
            ||
            null
            ,
            
                opacity: item.opacity
            ||
            null
            ,
            
                position: item.position
            ||
            null
            ,
            
                scale: item.scale
            ||
            null
            ,
            
                enabled: item.enabled
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const watermark_profiles = await db.watermark_profiles.bulkCreate(watermark_profilesData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < watermark_profiles.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.watermark_profiles.getTableName(),
                    belongsToColumn: 'watermark_image',
                    belongsToId: watermark_profiles[i].id,
                },
                data[i].watermark_image,
                options,
            );
        }
        

        return watermark_profiles;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const watermark_profiles = await db.watermark_profiles.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.mode !== undefined) updatePayload.mode = data.mode;
        
        
        if (data.default_text_template !== undefined) updatePayload.default_text_template = data.default_text_template;
        
        
        if (data.opacity !== undefined) updatePayload.opacity = data.opacity;
        
        
        if (data.position !== undefined) updatePayload.position = data.position;
        
        
        if (data.scale !== undefined) updatePayload.scale = data.scale;
        
        
        if (data.enabled !== undefined) updatePayload.enabled = data.enabled;
        
        
        updatePayload.updatedById = currentUser.id;

        await watermark_profiles.update(updatePayload, {transaction});

        
        
        if (data.organization !== undefined) {
            await watermark_profiles.setOrganization(
              
              (globalAccess ? data.organization : currentUser.organization.id),
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.watermark_profiles.getTableName(),
                belongsToColumn: 'watermark_image',
                belongsToId: watermark_profiles.id,
            },
            data.watermark_image,
            options,
        );
        

        return watermark_profiles;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const watermark_profiles = await db.watermark_profiles.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of watermark_profiles) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of watermark_profiles) {
                await record.destroy({transaction});
            }
        });


        return watermark_profiles;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const watermark_profiles = await db.watermark_profiles.findByPk(id, options);

        await watermark_profiles.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await watermark_profiles.destroy({
            transaction
        });

        return watermark_profiles;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const watermark_profiles = await db.watermark_profiles.findOne(
            { where },
            { transaction },
        );

        if (!watermark_profiles) {
            return watermark_profiles;
        }

        const output = watermark_profiles.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.download_jobs_watermark_profile = await watermark_profiles.getDownload_jobs_watermark_profile({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.organization = await watermark_profiles.getOrganization({
            transaction
        });
        
        
        output.watermark_image = await watermark_profiles.getWatermark_image({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.organizations,
        as: 'organization',
        
      },



      {
        model: db.file,
        as: 'watermark_image',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'watermark_profiles',
                        'name',
                        filter.name,
                    ),
                };
            }
            
            if (filter.default_text_template) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'watermark_profiles',
                        'default_text_template',
                        filter.default_text_template,
                    ),
                };
            }
            

            
            

            
            if (filter.opacityRange) {
                const [start, end] = filter.opacityRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    opacity: {
                    ...where.opacity,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    opacity: {
                    ...where.opacity,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.scaleRange) {
                const [start, end] = filter.scaleRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    scale: {
                    ...where.scale,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    scale: {
                    ...where.scale,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.mode) {
                where = {
                    ...where,
                mode: filter.mode,
            };
            }
            
            if (filter.position) {
                where = {
                    ...where,
                position: filter.position,
            };
            }
            
            if (filter.enabled) {
                where = {
                    ...where,
                enabled: filter.enabled,
            };
            }
            


      
      if (filter.organization) {
        const listItems = filter.organization.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.watermark_profiles.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'watermark_profiles',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.watermark_profiles.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

